#include "fivewin.ch"
#include "urllink.ch"

//----------------------------------------------------------------------------//

static cText      := ""
static cImage     := ""
static cImgType   := "INVALID"
static nWidth     := 0
static nHeight    := 0
static oDlg, oGet, oClip

//----------------------------------------------------------------------------//

function Main()

   local oFixed, oFont, oBold, oImage, oUrl

   DEFINE FONT oFont  NAME "TAHOMA" SIZE 0,-14
   DEFINE FONT oBold  NAME "TAHOMA" SIZE 0,-20 BOLD
   DEFINE FONT oFixed NAME "LUCIDA CONSOLE" SIZE 0,-14

   DEFINE DIALOG oDlg SIZE 900,840 PIXEL TRUEPIXEL FONT oFont ;
      TITLE "BASE64 ENCODED IMAGES"

   @  20, 20 BUTTON "Read From File" SIZE 200,40 PIXEL OF oDlg ;
      ACTION ReadFromFile()

   @  20,680 BUTTON "Paste from ClipBoard" SIZE 200,40 PIXEL OF oDlg ;
      WHEN !Empty( oClip:GetText() ) ;
      ACTION PasteText()


   @  80, 20 GET oGet VAR cText MEMO SIZE 860,240 PIXEL OF oDlg ;
      READONLY FONT oFixed

   @ 360, 20 XIMAGE oImage SOURCE cImage SIZE 500,400 OF oDlg UPDATE

   @ 400,550 SAY { || "Image Type : " + cImgType } SIZE 300,30 PIXEL OF oDlg UPDATE FONT oBold ;
         COLOR CLR_HRED,oDlg:nClrPane

   @ 440,550 SAY { || "Image Size : " + ;
                      cValToChar( oImage:nImgWidth  ) + " x " + ;
                      cValToChar( oImage:nImgHeight ) } ;
         SIZE 300,30 PIXEL OF oDlg UPDATE FONT oBold ;
         COLOR CLR_HRED,oDlg:nClrPane

   @ 700,600 BUTTON "SAVE" SIZE 200,40 PIXEL OF oDlg ACTION Save() ;
         WHEN Left( cImgType, 4 ) == "IMG."


   @ 780, 20 SAY "Cross Check Here :" SIZE 200,26 PIXEL OF oDlg
   @ 780,240 URLLINK oUrl URL "https://codebeautify.org/base64-to-image-converter" ;
      PIXEL OF oDlg FONT oFont



   oDlg:bInit := <||
      oGet:LimitText( 0 )
      DEFINE CLIPBOARD oClip OF oDlg FORMAT TEXT
      return nil
      >

   ACTIVATE DIALOG oDlg CENTERED

   RELEASE FONT oFont, oBold, oFixed

return nil

//----------------------------------------------------------------------------//

static function ReadFromFile()

   local cFile    := cGetFile( "(*.txt)|*.txt|" )
	local nAt
   
   if !Empty( cFile )
      cText    := MEMOREAD( cFile )
      
    if ( nAt := AT( 'Signature"=>', cText ) ) > 0
      cText    := SubStr( cText, nAt + 13 ) 
      cText := left( cText, len(cText)-2) 
     endif 
      Blob2Image( cText )

      oGet:SetText( Left( cText, 10000 ) )
      oDlg:Update()

   endif

return nil

//----------------------------------------------------------------------------//

static function PasteText()

   cText    := oClip:GetText()
   oClip:Clear()
   Blob2Image( cText )

   oGet:SetText( Left( cText, 10000 ) )
   oDlg:Update()

return nil

//----------------------------------------------------------------------------//
static FUNCTION URLEncode( cStr )
  
  
  cStr := STRTRAN(cStr, '%3D', '=' )
  cStr := STRTRAN(cStr, "%3A", ":" )
  cStr := STRTRAN(cStr, "%2F", "/" )
   cStr := STRTRAN(cStr, "%2C", "," )
  cStr := STRTRAN(cStr, "%2B", "+" )  
    cStr := STRTRAN(cStr, "%3B", ";" )
                                          
  
  /* LOCAL cRet := "", i, nVal, cCar

   FOR i := 1 TO Len( cStr )
      cCar := cStr[i]
      DO CASE

         CASE cCar == " "
              cRet += "+"

         CASE cCar >= "A" .and. cCar <= "Z"
            cRet += cCar

         CASE cCar >= "a" .and. cCar <= "z"
            cRet += cCar

         CASE cCar >= "0" .and. cCar <= "9"
            cRet += cCar

         OTHERWISE
            nVal := Asc( cCar )
            cRet += "%" + NumToHex( nVal )
      ENDCASE
   NEXT
*/



RETURN cStr

static function Blob2Image( cText )

   local nAt
   local lValid   := .t.
cText := URLEncode( cText )
? cText

memowrit("convert.txt",cText)

   if ( nAt := AT( "base64", cText ) ) > 0
      cText    := SubStr( cText, nAt + 6 )
      if Left( cText, 1 ) == ","
         cText := SubStr( cText, 2 )
      elseif UPPER( Left( cText, 3 ) ) == "%2C"
         cText := SubStr( cText, 4 )
      else
         lValid := .f.
      endif
      if lValid
         do while Right( cText, 1 ) $ [>)"]
            cText := Left( cText, Len( cText ) - 1 )
         enddo
         cImage   := HB_BASE64DECODE( cText )
         cImgType := MemoryBufferType( cImage )
      endif
   else
      lValid   := .f.
   endif

   if !lValid
      cImage   := ""
      cImgType := "INVALID"
   endif

return cImage

//----------------------------------------------------------------------------//

static function Save()

   local cMask, cFile, cExt, cPrompt

   if !( LEFT( cImgType, 4 ) == "IMG." )
      return nil
   endif

   cMask    := "*" + Lower( SubStr( cImgType, 4 ) )
   cExt     := SubStr( cMask, 3 )
   cPrompt  := "Image File(" + cMask + ")|" + cMask + "|"

   cFile    := cGetFile( cPrompt, "Select File to Save",1, nil, .T. )

   if !Empty( cFile )
      cFile    := cFileSetExt( cFile, cExt )
      if MEMOWRIT( cFile, cImage, .f. )
         ? "Saved to " + cFile
         XImage( cFile )
      else
         ? "Failed to save to " + cFile
      endif
   endif

return nil

//----------------------------------------------------------------------------//

